Public Class Form1

    ' GetPrivateProfileString is used for retrieving dialog variables from the config file.
    Private Declare Function GetPrivateProfileString Lib "kernel32.dll" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFileName As String) As Integer
    ' WritePrivateProfileString is used for saving dialog variables to the config file.
    Private Declare Function WritePrivateProfileString Lib "kernel32.dll" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As String, ByVal lpFileName As String) As Integer


    Shared counter As Integer   ' a global variable to keep track of how many times the plugin is used by the config.
    Shared email As String      ' a global test variable 
    Shared dialog As New Form1()    ' the configure dialog

    '======================================================================
    '== DLLTYPE ===========================================================
    '======================================================================
    Public Shared Function dlltype() As Integer
        Return 1    ' 1=Source; 2=Visual; 3=Source+Visual; 4=Input; 5=Input+Source; 6=Input+Visual; 7=Input+Source+Visual
    End Function

    '======================================================================
    '== DLLSTARTUP ========================================================
    '======================================================================
    Public Shared Function dllstartup(ByRef SammysHandle As UInteger, ByRef plugintype As Integer) As Integer
        counter += counter  ' increment the counter each time the plugin is started by Samurize
        Return counter  'return a unique number (this is useful for storing data for different instances)
    End Function

    '======================================================================
    '== DLLSHUTDOWN =======================================================
    '======================================================================
    Public Shared Function dllshutdown(ByVal id As Integer) As Integer
        If dialog.Visible Then ' close the dialog if it's still showing
            dialog.Close()
        End If
        Return 0
    End Function

    '======================================================================
    '== GETINFO ===========================================================
    '======================================================================
    Public Shared Function getinfo(ByVal number As Integer) As String
        Dim result As String = ""
        Select Case number
            Case 0 : result = "Visual Basic example"
            Case 1 : result = "uziq"
            Case 2 : result = "1.0"
            Case 3 : result = "November 21 2005"
            Case 4 : result = "November 28 2005"
            Case 5 : result = "http://www.geocities.com/samurize@swbell.net/samurize.html"
            Case 6 : result = "uziq@hotmail.com"
        End Select
        'MessageBox.Show(number & vbCrLf & result)
        Return result
    End Function

    '======================================================================
    '== INIT (SOURCE PLUGINS) =============================================
    '======================================================================
    Public Shared Function init() As String
        Dim funclist As String
        funclist = "HelloWorld"
        Return funclist
    End Function

    '======================================================================
    '== GETPARAM (SOURCE PLUGINS) =========================================
    '======================================================================
    Public Shared Function getparam(ByVal func As String) As String
        Dim paramlist As String
        If func = "HelloWorld" Then
            paramlist = "Enter your first name|Enter your last name|"
        Else
            paramlist = ""
        End If
        Return paramlist
    End Function

    '======================================================================
    '== CONFIGURE (SOURCE PLUGINS - GLOBAL) ===============================
    '======================================================================
    Public Shared Function configure() As Integer
        Return 0
    End Function

    '======================================================================
    '== SOURCE_CONFIGURE (SOURCE PLUGINS - PER METER) =====================
    '======================================================================
    Public Shared Function source_configure(ByVal id As Integer, ByVal func As String) As Integer
        If func = "HelloWorld" Then
            'show the configure dialog
            If dialog.Visible Then ' if the dialog is already showing..
                dialog.Focus()  ' re-focus
            Else
                dialog.Show()   ' show 
            End If
        End If
        Return 0
    End Function

    '======================================================================
    '== SRC_LOAD_SETTINGS (SOURCE PLUGINS) ================================
    '======================================================================
    Public Shared Function src_load_settings(ByVal id As Integer, ByVal ini As String, ByVal section As String) As Integer
        Dim temp As String = Space(1000)
        GetPrivateProfileString(section, "email", "", temp, temp.Length, ini)
        email = temp
        Return 0
    End Function

    '======================================================================
    '== SRC_SAVE_SETTINGS (SOURCE PLUGINS) ================================
    '======================================================================
    Public Shared Function src_save_settings(ByVal id As Integer, ByVal ini As String, ByVal section As String) As Integer
        WritePrivateProfileString(section, "email", email, ini)
        Return 0
    End Function

    '======================================================================
    '== HELLOWORLD ========================================================
    '======================================================================
    Public Shared Function HelloWorld(ByVal id As Integer, ByVal param1 As String, ByVal param2 As String) As String
        Dim result As String
        If Len(param1) Then
            If Len(param2) Then
                result = "Hello " & param1 & " " & param2 & "!"
            Else
                result = "Hello " & param1 & "!"
            End If
        Else
            result = "Hello!"
        End If
        If Len(email) Then
            result = result & vbCrLf & "email: " & email
        Else
            result = result & vbCrLf & "Click the Configure button to enter your email address."
        End If
        Return result
    End Function


    '======================================================================
    '======================================================================
    '== DIALOG STUFF ======================================================
    '======================================================================
    '======================================================================

    Private Sub ButtonOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonOK.Click
        ' get the email address from the textbox and store it in the email variable:
        email = emailTextbox.Text
        dialog.Hide()
    End Sub

    Private Sub ButtonCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonCancel.Click
        dialog.Hide()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load, MyBase.VisibleChanged
        ' put the existing email address into the email textbox:
        emailTextbox.Text = email
    End Sub

End Class
